/* Wrong solution for the task Triangulations
 * Author: Jakub Radoszewski
 * Date: 27.05.2007
 * Description: Assumes that m is prime.
 */

#include<cstdio>
#include<cctype>
#include<cmath>
#include<cstdlib>
#include<algorithm>
#include<vector>
#include<string>
#include<list>
#include<deque>
#include<map>
#include<set>
#include<queue>
#include<stack>
#include<utility>
#include<sstream>
#include<cstring>
using namespace std;

#define FOR(I,A,B) for(int I=(A);I<=(B);I++)
#define FORD(I,A,B) for(int I=(A);I>=(B);I--)
#define REP(I,N) for(int I=0;I<(N);I++)
#define ALL(X) (X).begin(),(X).end()
#define PB push_back
#define MP make_pair
#define FI first
#define SE second
#define INFTY 100000000
#define VAR(V,init) __typeof(init) V=(init)
#define FOREACH(I,C) for(VAR(I,(C).begin());I!=(C).end();I++)

typedef vector<int> VI;
typedef pair<int,int> PII;
typedef long long ll;
typedef vector<string> VS;

ll nwd(ll a,ll b) { return !b?a:nwd(b,a%b); }
inline int CEIL(int a,int b) { return a%b ? a/b+1 : a/b; }
template <class T> inline T sqr(const T&a) { return a*a; }

#define MAX_N 100000

int n,m;
int cat[MAX_N+1];

/* Extended Euclid.
 * For a i b counts (p,q,d) such that ap+bq=d. */
void euclid(int a, int b, ll &p, ll &q, int &d)
{
	if (!b) { p=1; q=0; d=a; } else
	{
		ll p1,q1; int d1;
		euclid(b,a%b,p1,q1,d1);
		d=d1;
		p=q1; q=p1-q1*(a/b);
	}
}

/* Reciprocal of v modulo p (NWD(v,p)=1). */
int revmod(int v,int p)
{
  ll x,y; int z;
  euclid(v,p,x,y,z);
  return int(x%p+p)%p;
}

void doit()
{
  ll sum=1LL;
  cat[3]=1;
  FOR(i,4,n)
  {
    /* from one Catalan number to another one */
    int nr=i-3;
    cat[i]=(2*cat[i-1])%m;
    cat[i]=int(((ll)cat[i]*(2*nr+1))%m);
    cat[i]=int(((ll)cat[i]*revmod(nr+2,m))%m);
    sum+=cat[i];
  }
  printf("%lld\n",sum%m);
}

int main()
{
  scanf("%d %d",&n,&m);
  doit();
  return 0;
}
