/* Slow solution for the task Triangulations
 * Author: Jakub Radoszewski
 * Date: 27.05.2007
 * Description: Counts all Catalan numbers from 3-rd to n-th vika dynamic
 * programming.
 */

#include<cstdio>
#include<cctype>
#include<cmath>
#include<cstdlib>
#include<algorithm>
#include<vector>
#include<string>
#include<list>
#include<deque>
#include<map>
#include<set>
#include<queue>
#include<stack>
#include<utility>
#include<sstream>
#include<cstring>
using namespace std;

#define FOR(I,A,B) for(int I=(A);I<=(B);I++)
#define FORD(I,A,B) for(int I=(A);I>=(B);I--)
#define REP(I,N) for(int I=0;I<(N);I++)
#define ALL(X) (X).begin(),(X).end()
#define PB push_back
#define MP make_pair
#define FI first
#define SE second
#define INFTY 100000000
#define VAR(V,init) __typeof(init) V=(init)
#define FOREACH(I,C) for(VAR(I,(C).begin());I!=(C).end();I++)

typedef vector<int> VI;
typedef pair<int,int> PII;
typedef long long ll;
typedef vector<string> VS;

ll nwd(ll a,ll b) { return !b?a:nwd(b,a%b); }
inline int CEIL(int a,int b) { return a%b ? a/b+1 : a/b; }
template <class T> inline T sqr(const T&a) { return a*a; }

#define MAX_N 100000

int n,m;
int cat[MAX_N+1];

int main()
{
  scanf("%d %d",&n,&m);
  cat[0]=cat[1]=1;
  FOR(i,1,n) FOR(j,0,i) cat[i+1]=int((cat[i+1]+(ll)cat[j]*cat[i-j])%m);
  ll sum=0;
  FOR(i,1,n-2) sum+=cat[i];
  printf("%lld\n",sum%m);
  return 0;
}
